import gi

gi.require_version("Gtk", "3.0")
from gi.repository import Gtk
from gi.repository import Gdk

import os

def onDestroy(self, *args):
	Gtk.main_quit()

def on_cancelBtn(button):
	Gtk.main_quit()

def on_okBtn(button):
	global selectedFFN
	global selFile
	global selAct
	selList = selFile.get_filenames()
	for oneFN in selList:
		if len(selectedFFN) > 0:
			selectedFFN += "|" + oneFN
		else:
			selectedFFN = oneFN
		
	Gtk.main_quit()

def doSelFile(winSets, labData, acType):
	global selectedFFN
	global selAct
	global selFile

	selectedFFN = ""
	selAct = ""

	binDir, exe = __file__.rsplit('/', 1)
	binDir = binDir + '/'

	homeDir = os.path.expanduser('~')

	mainWin = Gtk.Window()
	mainWin.connect("destroy", onDestroy)
	mainWin.set_border_width(10)
	mainWin.set_position(Gtk.WindowPosition.CENTER)

	curFolder = ""
	useMulti = False
	vSpacing = 10
	lSpacing = 1
	defWd = -1
	defHt = -1
	for oneSet in winSets:
		if oneSet:
			if '=' in oneSet:
				key, val = oneSet.split("=", 1)
				if key == "t":
					mainWin.set_title(val)
				elif key == "i":
					mainWin.set_icon_from_file(val)
				elif key == "w":
					defWd = int(val)
				elif key == "h":
					defHt = int(val)
				elif key == "v":
					vSpacing = int(val)
				elif key == "l":
					lSpacing = int(val)
				elif key == "u":
					useMulti = val.startswith("y") or val.startswith("Y")
				elif key == "d":
					curFolder = val
	if defWd > 0 or defHt > 0:
		mainWin.set_default_size(defWd, defHt)

	vbox = Gtk.Box(orientation=Gtk.Orientation.VERTICAL, spacing=vSpacing)
	mainWin.add(vbox)

	lbox = Gtk.Box(orientation=Gtk.Orientation.VERTICAL, spacing=lSpacing)
	for oneLab in labData:
		label = Gtk.Label()
		if oneLab.startswith("["):
			label.set_xalign(0.0)
			oneLab = oneLab[1:]
		if oneLab.startswith("^"):
			label.set_name("ghilab")
			oneLab = oneLab[1:]
		if '<' in oneLab:
			label.set_markup(oneLab)
		else:
			label.set_text(oneLab)
		lbox.pack_start(label, True, True, 0)
	vbox.pack_start(lbox, False, True, 0)

	selFile = Gtk.FileChooserWidget()
	if curFolder:
		selFile.set_current_folder(curFolder)
	vbox.pack_start(selFile, True, True, 0)

	hbox = Gtk.ButtonBox()
	hbox.set_homogeneous(True)
	hbox.set_layout(Gtk.ButtonBoxStyle.SPREAD)

	button = Gtk.Button.new_with_label("Cancel")
	button.set_image(Gtk.Image.new_from_file(binDir + "icons/cancel.svg"))
	button.connect("clicked", on_cancelBtn)
	hbox.pack_start(button, True, True, 0)

	button = Gtk.Button.new_with_label("Ok")
	button.set_image(Gtk.Image.new_from_file(binDir + "icons/ok.svg"))
	button.connect("clicked", on_okBtn)
	hbox.pack_start(button, True, True, 0)

	vbox.pack_start(hbox, False, True, 0)

	selAct = acType
	if selAct == "d":
		selFile.set_action(Gtk.FileChooserAction.SELECT_FOLDER)
	else:
		selFile.set_action(Gtk.FileChooserAction.OPEN)
		selFile.set_select_multiple(useMulti)


	cssPath = os.path.join(homeDir, '.config', 'ggwins.css')
	if not os.path.exists(cssPath):
		cssPath = os.path.join(binDir,  'ggwins.css')
		if not os.path.exists(cssPath):
			cssPath = ''
	if cssPath:
		provider = Gtk.CssProvider()
		provider.load_from_path(cssPath)
		Gtk.StyleContext.add_provider_for_screen(Gdk.Screen.get_default(), provider, Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)

	mainWin.show_all()

	Gtk.main()
	return selectedFFN
